---
dg-publish: true
---
2 de Outubro, 2023 - #ASCN 

------
## 1. Provisioning

>[!hint] Provisioning is the action of providing or supplying something for use.

1. Server provisioning
2. Storage provisioning
3. Network provisioning
4. VM provisioning
5. User provisioning


## 2. Deployment

>[!hint] Deployment is the process of installing or upgrading an application/service into a server.

- Installing or upgrading a web application (files, migrations, assets...)
- Network service installation or upgrade
- The scope is the service or application

>[!note]- Provisioning and deployment are boring after the 1st iteration...
>- repetitive process
>- may spread across multiple and heterogeneous systems
>- will probably require tweaks overtime
>- sometimes a time consuming task


## 3. Configuration Management

>[!hint] A way of handling systematic system changes while maintaining integrity throughout its lifecycle.

- Express configuration through a common dialect
- Predictable configuration result
- Configuration evolves with the infrastructure
- Infrastructure documentation as a positive side effect
- Full history of changes overtime when used with source code management
- Changes are observable
- Process Automation
- Each unit of work is expressed as a recipe

